IMPLEMENTATION MODULE MMSys;

IMPORT MMSystem, Lib3;


CONST period = 1;  (* in ms, 0 doesn't work *)


(* SOL 20170620: WinBase.GetTickCount() has granularity of 16ms, see msdn, which is too coarse *)
(* MMSystem.timeGetSystemTime() yields values as good as WinBase.GetLocalTime()                *)
(* SOL 20191226: MMSystem.timeBeginPeriod() solves the granularity problem (on some machines)  *)
(* SOL 20191227: MMSystem.timeGetTime() yields same value as MMSystem.timeGetSystemTime()      *)
(* SOL 20200109: WinSock.select() timeouts more frequently if timeEndPeriod(1) is called        *)

PROCEDURE Ticks(): LONGCARD;
BEGIN
  RETURN MMSystem.timeGetTime();
END Ticks;


VAR
  oldTerm: PROC;

PROCEDURE DoneModule();
BEGIN
  IF MMSystem.timeEndPeriod( period ) # 0 THEN
    Lib3.FatalError( 'MMSys: timeEndPeriod failed' );
  END;
  oldTerm();
END DoneModule;

BEGIN
  IF MMSystem.timeBeginPeriod( period ) # 0 THEN
    Lib3.FatalError( 'MMSys: timeBeginPeriod failed' );
  END;
  Lib3.Terminate( DoneModule, oldTerm );
END MMSys.
